/*

 methods_2
 questo sorgente e' parte integrante 
 del Progetto xSudoky.
 Scritto da Max Cavallo 20/Luglio/2007
 ixamit@gmail.com

*/

#include "sudoky.h"
#include <libintl.h>
#include <locale.h>

int label_Tipo;

//====================================================
//
//-------------------------NAKED----------------------
//
//====================================================
int NakedCancella (int Tipo,int Riga_o_Colonna_o_Blocco,int Candidati, int BitSet)
{
	//
	// Richiamata da Metodo Naked Righe/Colonne/Blocchi
	//
	// Elimina i candidati sulla Riga o Colonna o Blocco
	// (definito da Tipo)
	//

	int b,p,x,y;
	int num_naked;
	int count,test;
	int k,Candidato;
	char *ptr;
	
	num_naked=ContaBits(BitSet);
	count=0;

	if (Tipo==1)
	{
		// su Riga
		y=Riga_o_Colonna_o_Blocco;

		// Prepara eventuale 1^ messaggio
		// --inizio
		sprintf (BUFF,
			gettext("  Found [%s] in"),GetCandidati2(Candidati));
		for (x=0;x<SUD_TAB;x++)
		{
			if (BitSet & (1<<x))
			{
				if (++count < num_naked)
					sprintf (BUFF,gettext("%s R%dC%d,"),
					BUFF,y+1,x+1);
				else
					sprintf (BUFF,gettext("%s R%dC%d"),
					BUFF,y+1,x+1);
			}
		}
		// --fine messaggio

		count=0;
		for (x=0;x<SUD_TAB;x++)
		{
			if (
				IsCandi (y,x) &&
				(BitSet & (1 << x))==0
			)
			{
				test=SUD_BUF[y][x] & Candidati;
				UnsetFlagCandidato (&test, CANDI_MSK);
				if (test)
				{
					
					if (label_Tipo++==0)
					{
						AddItemListCmd (ViewComment, LABEL,
						gettext("NAKED ROW"),NULL);
					}

					count++;
					if (count==1)
					{
						AddItemListCmd (ViewComment, LIST_BOX, BUFF,SudoListBoxCallBack);
					}
		
					ptr=GetCandidati2(test);

					sprintf (BUFF,
						gettext("    Unset [%s] in R%dC%d"),
						ptr,y+1,x+1);

					AddItemListCmd (ViewComment, LIST_BOX, BUFF,SudoListBoxCallBack);

					for (k=0;k<strlen(ptr);k++)
					{
						Candidato=ptr[k]-'0';
						RemoveCandidatoGUI(y,x,Candidato,0);
					}
						
						
				}
			}
		}
		
	}
	if (Tipo==2)
	{
		// su Colonna
		x=Riga_o_Colonna_o_Blocco;

		// Prepara eventuale 1^ messaggio
		// --inizio
		sprintf (BUFF,gettext("  Found [%s] in"),
			GetCandidati2(Candidati));
		for (y=0;y<SUD_TAB;y++)
		{
			if (BitSet & (1<<y))
			{
				if (++count < num_naked)
					sprintf (BUFF,
						gettext("%s R%dC%d,"),
						BUFF,y+1,x+1);
				else
					sprintf (BUFF,
						gettext("%s R%dC%d"),
						BUFF,y+1,x+1);
			}
		}
		// --fine messaggio

		count=0;
		for (y=0;y<SUD_TAB;y++)
		{
			if (
				IsCandi (y,x) &&
				(BitSet & (1 << y))==0
			)
			{
				test=SUD_BUF[y][x] & Candidati;
				UnsetFlagCandidato (&test, CANDI_MSK);
				if (test)
				{
					if (label_Tipo++==0)
					{
						AddItemListCmd (ViewComment, LABEL,
						gettext("NAKED COLUMN"),NULL);
					}

					count++;
					if (count==1)
					{
						AddItemListCmd (ViewComment, LIST_BOX, BUFF,SudoListBoxCallBack);
					}
		
					ptr=GetCandidati2(test);

					sprintf (BUFF,
						gettext("    Unset [%s] in R%dC%d"),
						ptr,y+1,x+1);

					AddItemListCmd (ViewComment, LIST_BOX, BUFF,SudoListBoxCallBack);

					for (k=0;k<strlen(ptr);k++)
					{
						Candidato=ptr[k]-'0';
						RemoveCandidatoGUI(y,x,Candidato,0);
					}
						
						
				}
			}
		}
	}

	if (Tipo==3)
	{
		// su Blocco
		b=Riga_o_Colonna_o_Blocco;

		// Prepara eventuale 1^ messaggio
		// --inizio
		sprintf (BUFF,gettext("  Found [%s] in"),
			GetCandidati2(Candidati));
		for (p=0;p<SUD_TAB;p++)
		{
			if (BitSet & (1<<p))
			{
				CoordinateBlocco2yx (b,p,&y,&x);
				if (++count < num_naked)
					sprintf (BUFF,
						gettext("%s R%dC%d,"),
						BUFF,y+1,x+1);
				else
					sprintf (BUFF,
						gettext("%s R%dC%d"),
						BUFF,y+1,x+1);
			}
		}
		// --fine messaggio

		count=0;
		for (p=0;p<SUD_TAB;p++)
		{
			CoordinateBlocco2yx (b,p,&y,&x);
			if (
				IsCandi (y,x) &&
				(BitSet & (1 << p))==0
			)
			{
				test=SUD_BUF[y][x] & Candidati;
				UnsetFlagCandidato (&test, CANDI_MSK);
				if (test)
				{
					if (label_Tipo++==0)
					{
						AddItemListCmd (ViewComment, LABEL,
						gettext("NAKED BOX"),NULL);
					}

					count++;
					if (count==1)
					{
						AddItemListCmd (ViewComment, LIST_BOX, BUFF,SudoListBoxCallBack);
					}
		
					ptr=GetCandidati2(test);

					sprintf (BUFF,
						gettext("    Unset [%s] in R%dC%d"),
						ptr,y+1,x+1);

					AddItemListCmd (ViewComment, LIST_BOX, BUFF,SudoListBoxCallBack);

					for (k=0;k<strlen(ptr);k++)
					{
						Candidato=ptr[k]-'0';
						RemoveCandidatoGUI(y,x,Candidato,0);
					}
						
						
				}
			}
		}
	
	}
	
	return (0);
}
int NakedRiga ()
{
	// 
	int x,y;
	int x1,test,count,set;

	for (y=0;y<SUD_TAB;y++)
	{
		for (x=0;x<SUD_TAB;x++)
		{
			count=1;set=0;
			set |= (1 << x);
			for (x1=0;
				(IsCandi (y,x)) && 
				x1<SUD_TAB;
				x1++)
			{
				if (
					(x1!=x) && 
					(IsCandi (y,x1)) &&
					(ContaBits (SUD_BUF[y][x])>=ContaBits (SUD_BUF[y][x1]))
				)
				{

					test=SUD_BUF[y][x] & SUD_BUF[y][x1];
					if (

						test==SUD_BUF[y][x] ||
						test==SUD_BUF[y][x1]

					)
					{
						count++;
						set |= (1 << x1);
					}
				}
			}
			if (count>1 && (count==ContaBits (SUD_BUF[y][x])))
			{
				NakedCancella (1,y,SUD_BUF[y][x],set);
			}
		}
	}
	label_Tipo=0;
	return (0);
	
}
int NakedColonna ()
{
	int x,y;
	int y1,test,count,set;

	for (x=0;x<SUD_TAB;x++)
	{
		for (y=0;y<SUD_TAB;y++)
		{
			count=1;set=0;
			set |= (1 << y);
			for (y1=0;(IsCandi (y,x)) && y1<SUD_TAB;y1++)
			{
				if (
					(y1!=y) &&
					(IsCandi (y1,x)) &&
					(ContaBits (SUD_BUF[y][x])>=ContaBits (SUD_BUF[y1][x]))
				)
				{
					test=SUD_BUF[y][x] & SUD_BUF[y1][x];
					if (
						test==SUD_BUF[y][x] ||
						test==SUD_BUF[y1][x]
					)
					{
						count++;
						set |= (1 << y1);
					}
				}
			}
			if (count>1 && (count==ContaBits (SUD_BUF[y][x])))
			{
				NakedCancella (2,x,SUD_BUF[y][x],set);
			}
		}
	}
	label_Tipo=0;
	return (0);
	
}
int NakedBlocco ()
{
	int b,p,x,y;
	int p1,x1,y1,test,count,set;

	for (b=0;b<SUD_TAB;b++)
	{
		for (p=0;p<SUD_TAB;p++)
		{
			count=1;set=0;
			set |= (1 << p);

			CoordinateBlocco2yx (b,p,&y,&x);
			for (p1=0;(IsCandi (y,x)) && p1<SUD_TAB;p1++)
			{
				CoordinateBlocco2yx (b,p1,&y1,&x1);
				if (
					(p1!=p) &&
					(IsCandi (y1,x)) &&
					(ContaBits (SUD_BUF[y][x])>=ContaBits (SUD_BUF[y1][x1]))
				)
				{
					test=SUD_BUF[y][x] & SUD_BUF[y1][x1];
					if (
						test==SUD_BUF[y][x] ||
						test==SUD_BUF[y1][x1]
					)
					{
						count++;
						set |= (1 << p1);
					}
				}
			}
			if (count>1 && (count==ContaBits (SUD_BUF[y][x])))
			{
				NakedCancella (3,b,SUD_BUF[y][x],set);
			}
		}
	}
	label_Tipo=0;
	return (0);
	
}

int Naked ()
{
	Clear_Comments ();

	NakedRiga();
	NakedColonna ();
	NakedBlocco ();

	SudoFinish(SOLVE); //ex 1 fisso

	return (0);
}

//====================================================
//
//-------------------------HIDDEN---------------------
//
//====================================================
int CancellaHidden(int Tipo,int Riga_o_Colonna_o_Blocco,int BitPos,int set)
{
	int y,x,b,p;
	int z,k;
	char *candidati=NULL;

	x=-1;y=-1;
	if (Tipo==1)
	{
		y=Riga_o_Colonna_o_Blocco;
		for (x=0;x<SUD_TAB;x++)
		{
			if (BitPos & (1<<x))
			{
				z=SUD_BUF[y][x] & ~set;
				UnsetFlagCandidato (&z, CANDI_MSK);

				if (z)
				{
					candidati=GetCandidati2(z);

					sprintf (BUFF,
						gettext("    Unset [%s] in R%dC%d"),
						candidati,y+1,x+1);

					AddItemListCmd (ViewComment, LIST_BOX, BUFF,SudoListBoxCallBack);

					for (k=0;k<strlen(candidati);k++)
					{
						RemoveCandidatoGUI(y,x,(candidati[k]-'0'),0);
					}
				}
			}
		}
	}
	if (Tipo==2)
	{
		x=Riga_o_Colonna_o_Blocco;
		for (y=0;y<SUD_TAB;y++)
		{
			if (BitPos & (1<<y))
			{
				z=SUD_BUF[y][x] & ~set;
				UnsetFlagCandidato (&z, CANDI_MSK);
				if (z)
				{
					candidati=GetCandidati2(z);

					sprintf (BUFF,
						gettext("    Unset [%s] in R%dC%d"),
						candidati,y+1,x+1);

					AddItemListCmd (ViewComment, LIST_BOX, BUFF,SudoListBoxCallBack);

					for (k=0;k<strlen(candidati);k++)
					{
						RemoveCandidatoGUI(y,x,(candidati[k]-'0'),0);
					}
				}
			}
		}
	}
	if (Tipo==3)
	{
		b=Riga_o_Colonna_o_Blocco;
		for (p=0;p<SUD_TAB;p++)
		{
			if (BitPos & (1<<p))
			{
				CoordinateBlocco2yx (b,p,&y,&x);

				z=SUD_BUF[y][x] & ~set;
				UnsetFlagCandidato (&z, CANDI_MSK);
				if (z)
				{
					candidati=GetCandidati2(z);

					sprintf (BUFF,
						gettext("    Unset [%s] in R%dC%d"),
						candidati,y+1,x+1);

					AddItemListCmd (ViewComment, LIST_BOX, BUFF,SudoListBoxCallBack);

					for (k=0;k<strlen(candidati);k++)
					{
						RemoveCandidatoGUI(y,x,(candidati[k]-'0'),0);
					}
				}
			}
		}
	}

	return (0);
}

int VerificaHidden(int Tipo,int Riga_o_Colonna_o_Blocco,int tmp[SUD_TAB])
{

	int j,k,z;
	int y,x,b,p;
	int count,num_hidden;
	int set,test;

	for (j=0;j<SUD_TAB;j++)
	{
		set=0x0; test=0x0;
		for (k=j+1;k<SUD_TAB;k++)
		{
			if (tmp[j]==tmp[k])
			{
				if (set==0) set = (1 << (j));
				set |= (1 << (k));
			}
		}
		if (ContaBits (set)==ContaBits(tmp[j]))
		{
			if (Tipo==1)
			{
				y=Riga_o_Colonna_o_Blocco;
				for (x=0;x<SUD_TAB;x++)
				{
					if (tmp[j] & (1<<x))
					{ 
						z=SUD_BUF[y][x];
						UnsetFlagCandidato (&z, CANDI_MSK);
						if (z!=set) test=1;
					}
				}
				if (test)
				{
					//
					if (label_Tipo++==0)
					{
						AddItemListCmd (ViewComment, LABEL,
						gettext("HIDDEN ROW"),NULL);
					}

					num_hidden=ContaBits(set);
					sprintf (BUFF,
						gettext("  Found [%s] in"),
					GetCandidati2(set));
					for (x=0,count=0;x<SUD_TAB;x++)
					{
						if (tmp[j] & (1<<x))
						{
							if (++count < num_hidden)
								sprintf (BUFF,
								gettext("%s R%dC%d,"),
								BUFF,y+1,x+1);
							else
								sprintf (BUFF,
								gettext("%s R%dC%d"),
								BUFF,y+1,x+1);
						}
					}
				}
			}
			if (Tipo==2)
			{
				x=Riga_o_Colonna_o_Blocco;
				for (y=0;y<SUD_TAB;y++)
				{
					if (tmp[j] & (1<<y))
					{
						z=SUD_BUF[y][x];
						UnsetFlagCandidato (&z, CANDI_MSK);
						if (z!=set) test=1;
					}
				}
				if (test)
				{
					if (label_Tipo++==0)
					{
						AddItemListCmd (ViewComment, LABEL,
						gettext("HIDDEN COLUMN"),NULL);
					}

					num_hidden=ContaBits(set);
					sprintf (BUFF,
						gettext("  Found [%s] in"),
						GetCandidati2(set));
					for (y=0,count=0;y<SUD_TAB;y++)
					{
						if (tmp[j] & (1<<y))
						{
							if (++count < num_hidden)
								sprintf (BUFF,
								gettext("%s R%dC%d,"),
								BUFF,y+1,x+1);
							else
								sprintf (BUFF,
								gettext("%s R%dC%d"),
								BUFF,y+1,x+1);
						}
					}
				}
			}
			if (Tipo==3)
			{
				b=Riga_o_Colonna_o_Blocco;
				for (p=0;p<SUD_TAB;p++)
				{
					if (tmp[j] & (1<<p))
					{
						CoordinateBlocco2yx (b,p,&y,&x);

						z=SUD_BUF[y][x];
						UnsetFlagCandidato (&z, CANDI_MSK);
						if (z!=set) test=1;
					}
				}
				if (test)
				{
					if (label_Tipo++==0)
					{
						AddItemListCmd (ViewComment, LABEL,
						gettext("HIDDEN BOX"),NULL);
					}

					num_hidden=ContaBits(set);
					sprintf (BUFF,
						gettext("  Found [%s] in"),
						GetCandidati2(set));
					for (p=0,count=0;p<SUD_TAB;p++)
					{
						CoordinateBlocco2yx (b,p,&y,&x);
						if (tmp[j] & (1<<p))
						{
							if (++count < num_hidden)
								sprintf (BUFF,
								gettext("%s R%dC%d,"),
								BUFF,y+1,x+1);
							else
								sprintf (BUFF,
								gettext("%s R%dC%d"),
								BUFF,y+1,x+1);
						}
					}
				}
			}

			if (test)
			{
				AddItemListCmd (ViewComment, LIST_BOX, BUFF,SudoListBoxCallBack);

				CancellaHidden (Tipo,Riga_o_Colonna_o_Blocco,tmp[j],set);
				
			}
		}

	}
	return (0);
}

int HiddenRiga ()
{
	// 
	int x,y,k;
	int tmp[SUD_TAB];

	//AddItemListCmd (ViewComment, LABEL,
	//	gettext("HIDDEN ROW") , NULL);

	for (y=0;y<SUD_TAB;y++)
	{
		
		for (k=0;k<SUD_TAB;k++)
		{
			tmp[k]=0x0;
			for (x=0;x<SUD_TAB;x++)
			{
				if (SUD_BUF[y][x] & (1 << k))
					tmp[k] |= (1 << x);
			}
		}
		VerificaHidden(1,y,tmp);
	}
	label_Tipo=0;
	return (0);
}

int HiddenColonna ()
{
	// 
	int x,y,k;
	int tmp[SUD_TAB];

	//AddItemListCmd (ViewComment, LABEL,
	//	gettext("HIDDEN COLUMN") , NULL);

	for (x=0;x<SUD_TAB;x++)
	{
		
		for (k=0;k<SUD_TAB;k++)
		{
			tmp[k]=0x0;
			for (y=0;y<SUD_TAB;y++)
			{
				if (SUD_BUF[y][x] & (1 << k))
					tmp[k] |= (1 << y);
			}
		}
		VerificaHidden(2,x,tmp);
	}
	label_Tipo=0;
	return (0);
}

int HiddenBlocco ()
{
	// 
	int b,p,x,y,k;
	int tmp[SUD_TAB];

	
	//AddItemListCmd (ViewComment, LABEL,
	//	gettext("HIDDEN BOX") , NULL);

	for (b=0;b<SUD_TAB;b++)
	{
		
		for (k=0;k<SUD_TAB;k++)
		{
			tmp[k]=0x0;
			for (p=0;p<SUD_TAB;p++)
			{
				CoordinateBlocco2yx (b, p, &y, &x);
				if (SUD_BUF[y][x] & (1 << k))
					tmp[k] |= (1 << p);
			}
		}
		VerificaHidden(3,b,tmp);
	}
	label_Tipo=0;
	return (0);
}

int Hidden ()
{
	Clear_Comments ();

	HiddenRiga ();
	HiddenColonna ();
	HiddenBlocco ();

	SudoFinish(SOLVE); //ex 1 fisso

	return (0);
}

